﻿using System;
using System.Collections;
using System.Collections.Generic;

namespace PlatformBaseClasses.Collection_Examples.Examples
{
  class CustomEnumerator
  {
    public void RunExample()
    {
      Console.Write("\r\nEnumerating 5 random numbers\r\n  ");
      IEnumerable<int> randNumbers = new RandomNumbers(5);
      foreach (int rnd in randNumbers)
      {
        Console.Write("{0}, ", rnd);
      }
    }

    private sealed class RandomNumbers : IEnumerable<int>
    {
      private readonly int _countOfNumbers;
      private readonly Random _random = new Random();

      public RandomNumbers(int countOfNumbers)
      {
        _countOfNumbers = countOfNumbers;
      }

      public IEnumerator<int> GetEnumerator()
      {
        for (int i = 0; i < _countOfNumbers; i++)
        {
          yield return _random.Next();
        }
      }

      IEnumerator IEnumerable.GetEnumerator()
      {
        return GetEnumerator();
      }
    }
  }
}
