﻿using System;
using System.Collections.ObjectModel;

namespace PlatformBaseClasses.Collection_Examples.Examples
{
  public class ObservableCollectionSample
  {
    public void RunExample()
    {
      var observableCollection = new NameList();
      observableCollection.CollectionChanged += (sender, args) => Console.WriteLine("Collection Changed - {0}, {1}", args, sender);

      observableCollection.Add(new PersonName("first", "last"));
    }

    private class NameList : ObservableCollection<PersonName>
    {
      public NameList()
      {
        Add(new PersonName("Willa", "Cather"));
        Add(new PersonName("Isak", "Dinesen"));
        Add(new PersonName("Victor", "Hugo"));
        Add(new PersonName("Jules", "Verne"));
      }
    }

    private class PersonName
    {
      private string _firstName;
      private string _lastName;

      public PersonName(string first, string last)
      {
        _firstName = first;
        _lastName = last;
      }

      public string FirstName
      {
        get { return _firstName; }
        set { _firstName = value; }
      }

      public string LastName
      {
        get { return _lastName; }
        set { _lastName = value; }
      }
    }
  }
}
