﻿using System;

namespace PlatformBaseClasses.Disposable_Examples.Examples
{
  public class DisposableClass : IDisposable
  {
    public void Dispose() // NOT virtual  
    {
      Dispose(true);
      GC.SuppressFinalize(this); // Prevent finalizer from running.  
    }

    protected virtual void Dispose(bool disposing)
    {
      if (disposing)
      {
        // Call Dispose() on other objects owned by this instance.      
        // You can reference other finalizable objects here.
        Console.WriteLine(" Disposing everything including other finalizable objects");
      }
      // Release unmanaged resources owned by (just) this object.    
      Console.WriteLine(" Disposing internals of this object");
    }

    ~DisposableClass()
    {
      Dispose(false);
    }
  }
}
