﻿using System;
using System.IO;
using System.IO.Compression;

namespace PlatformBaseClasses.Stream_Examples
{
  public class CompressionStreamExample
  {
    public void RunExample()
    {
      using (Stream s = File.Create("compressed.bin"))
      {
        // DeflateStream == decorator
        using (Stream ds = new DeflateStream(s, CompressionMode.Compress))
        {
          for (byte i = 0; i < 100; i++)
          {
            ds.WriteByte(i);
          }
        }
      }

      using (Stream s = File.OpenRead("compressed.bin"))
      {
        using (Stream ds = new DeflateStream(s, CompressionMode.Decompress))
        {
          for (byte i = 0; i < 100; i++)
          {
            Console.WriteLine(ds.ReadByte()); // Writes 0 to 99
          }
        }
      }
    }
  }
}