using System;
using System.IO;

namespace PlatformBaseClasses.Stream_Examples
{
  internal class DirectoryInfoExample
  {
    public void RunExample()
    {
      // Specify the directories you want to manipulate.
      DirectoryInfo rootDirectoryInfo = new DirectoryInfo(@"d:\MyDir");
      DirectoryInfo tempDirectoryInfo = new DirectoryInfo(@"d:\MyDir\temp");

      try
      {
        // Create the directories.
        rootDirectoryInfo.Create();
        tempDirectoryInfo.Create();

        // This operation will not be allowed because there are subdirectories.
        Console.WriteLine("I am about to attempt to delete {0}.", rootDirectoryInfo.Name);
        rootDirectoryInfo.Delete();
        Console.WriteLine("The Delete operation was successful, which was unexpected.");
      }
      catch (Exception)
      {
        Console.WriteLine("The Delete operation failed as expected.");
      }
      finally
      {
        // cleanup
      }
    }
  }
}