using System;
using System.IO.Compression;

namespace PlatformBaseClasses.Stream_Examples
{
  internal class ZipExample
  {
    public void RunExample()
    {
      // create file from directory
      ZipFile.CreateFromDirectory(@"d:\SampleFolder", @"d:\SampleFolder.zip");

      // extract zip archive
      ZipFile.ExtractToDirectory(@"d:\SampleFolder.zip", @"d:\SampleFolder");

      // enumerate existit entries in archive
      using (ZipArchive zip = ZipFile.Open(@"d:\SampleFolder.zip", ZipArchiveMode.Read))
      {
        foreach (ZipArchiveEntry entry in zip.Entries)
        {
          Console.WriteLine(entry.FullName + " " + entry.Length);
        }
      }
    }
  }
}